#ifndef __FrameControl_H__
#define __FrameControl_H__


typedef unsigned int fk_FrameMode;

const fk_FrameMode FKUT_DEFAULT_FRAME	= 0x0000;
const fk_FrameMode FKUT_WAIT_FRAME		= 0x0001;
const fk_FrameMode FKUT_SKIP_FRAME		= 0x0002;

//=======================================================
//t[[g𐧌䂷NXłB
//======================================================
class fkut_FPS {
private:
	unsigned long	m_dwLastMinitues;
	unsigned long	m_dwFrameRate;
	unsigned long	m_dwSkipRate;
	float			m_fFrameTime;
	bool			m_bDrawFlag;

	bool			m_bInit;
	//=======================================================
	//݂̂PbPʂ̃[g̕\
	//======================================================
	unsigned long	m_dwFrameCount;
	unsigned long	m_dwSkipCount;

	fk_FrameMode	m_mode;
public:
	fkut_FPS(unsigned long = 60, fk_FrameMode = true);
	~fkut_FPS();

	bool			update();

	void			setFPS(unsigned long time);
	void			setFrameMode(fk_FrameMode);
	fk_FrameMode	getFrameMode(void);
	bool			getDrawFlag(void);

	unsigned long	getFPS(void);
	unsigned long	getSkipRate(void);
};

#endif
